package org.jvnet.hifaces.binding;

import javax.faces.context.FacesContext;

import org.jvnet.hifaces.function.Function0;

public class VariableFunction<R> extends Function0<R> {

	private static final long serialVersionUID = 1L;

	private final String variableName;

	public VariableFunction(Class<? extends R> type, String variableName) {
		super(type);
		this.variableName = variableName;
	}

	@SuppressWarnings("unchecked")
	@Override
	public R invoke(FacesContext facesContext) {
		final R variable = (R) facesContext.getApplication()
				.getVariableResolver().resolveVariable(facesContext,
						variableName);
		return variable;
	}
}
