package org.jvnet.hifaces.binding.message;

import javax.faces.context.FacesContext;

import org.jvnet.hifaces.binding.ValueBinding;
import org.springframework.context.MessageSourceResolvable;

public class LazyMessageSourceResolvableValueBinding extends
		AbstractSingleMessageValueBinding {

	private static final long serialVersionUID = 1L;

	private final ValueBinding message;

	public LazyMessageSourceResolvableValueBinding(ValueBinding message) {
		this.message = message;
	}

	public MessageSourceResolvable getMessage(FacesContext facesContext) {
		return (MessageSourceResolvable) message.getValue(facesContext);
	}

	protected String getMessageId(FacesContext facesContext) {
		final MessageSourceResolvable message = getMessage(facesContext);
		return message.getCodes()[0];
	}

	protected Object[] getArguments(FacesContext facesContext) {
		return getMessage(facesContext).getArguments();
	}

}
