package org.jvnet.hifaces.components.templatedpanel;

import java.io.IOException;
import java.util.Iterator;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

public abstract class AbstractTemplate implements Template {

  public static void renderChild(FacesContext facesContext, UIComponent child) throws IOException {
    if (!child.isRendered()) {
      return;
    }

    child.encodeBegin(facesContext);
    if (child.getRendersChildren()) {
      child.encodeChildren(facesContext);
    }
    else {
      renderChildren(facesContext, child);
    }
    child.encodeEnd(facesContext);
  }

  public static void renderChildren(FacesContext facesContext, UIComponent component)
      throws IOException {
    if (component.getChildCount() > 0) {
      for (Iterator it = component.getChildren().iterator(); it.hasNext();) {
        UIComponent child = (UIComponent) it.next();
        renderChild(facesContext, child);
      }
    }
  }

}
