//Copyright (c) 2006 by disy Informationssysteme GmbH
package org.jvnet.hifaces.components.templatedpanel.impl;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;

// NOT_PUBLISHED
public class ParseUtilities {

  private final static DocumentBuilder DOCUMENT_BUILDER;

  static {
    try {
      // Create document builder factory
      final DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
      // Turn namespace awareness on
      documentBuilderFactory.setNamespaceAware(true);
      // Create new document builder
      DOCUMENT_BUILDER = documentBuilderFactory.newDocumentBuilder();
    }
    catch (ParserConfigurationException pcex) {
      throw new ExceptionInInitializerError(pcex);
    }
  }

  public static Element parse(final URL url) throws IOException, SAXException {
    return parse(new BufferedInputStream(url.openStream(), 1024));
  }

  public static Element parse(final InputStream is) throws IOException, SAXException {
    final Document document;
    synchronized (DOCUMENT_BUILDER) {
      document = DOCUMENT_BUILDER.parse(is);
    }
    return document.getDocumentElement();
  }

}
