package org.jvnet.hifaces.function;

import java.io.Serializable;

import javax.faces.context.FacesContext;
import javax.faces.el.MethodBinding;
import javax.faces.el.MethodNotFoundException;

/**
 * Represents an abstract JSF function. Must be serializable in order to be able
 * to be used in component bindings.
 * 
 * @author valikov
 * 
 * @param <R>
 *            Return type.
 */
public abstract class Function<R> extends MethodBinding implements Serializable {

	private final Class<? extends R> type;

	public Function(final Class<? extends R> type) {
		super();
		this.type = type;
	}

	@Override
	public final Class<? extends R> getType(FacesContext facescontext)
			throws MethodNotFoundException {
		return getType();
	}

	public final Class<? extends R> getType() throws MethodNotFoundException {
		return type;
	}

}
