package org.jvnet.hifaces.myfaces.custom.tree2;

import org.apache.myfaces.custom.tree2.TreeWalker;
import org.apache.myfaces.custom.tree2.Tree;

public class SmartTreeWalker implements TreeWalker {

	private Tree tree;

	private boolean checkState = true;

	private boolean startedWalking = false;

	private final SmartTreeNode root;

	public SmartTreeWalker(SmartTreeNode root) {
		this.root = root;
	}

	public void setTree(Tree tree) {
		this.tree = tree;
	}

	public boolean isCheckState() {
		return checkState;
	}

	public void setCheckState(boolean checkState) {
		this.checkState = checkState;
	}

	public boolean next() {
		
		if (!startedWalking)
		{
			tree.setNodeId(root.getIdentifier());
			startedWalking = true;
			return true;
		}
		else
		{
			final SmartTreeNode current = root.getNodeById(tree.getNodeId());
			final SmartTreeNode next = current.getNextNode(checkState);
			if (next != null)
			{
				tree.setNodeId(next.getIdentifier());
				return true;
			}
			else
			{
				return false;
			}
		}
	}

	public String getRootNodeId() {
		return root.getIdentifier();
	}

	public void reset() {
		startedWalking = false;
	}
}
