package org.jvnet.hifaces.springframework.util;

import java.util.Collection;
import java.util.Enumeration;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.Set;

import javax.faces.context.FacesContext;

import org.springframework.context.NoSuchMessageException;

public class FacesContextResourceBundleBean extends ResourceBundle implements
		Map<String, String> {

	public static final String DEFAULT_MESSAGE_BUNDLE = "messages";

	private String defaultMessageBundle;

	public String getDefaultMessageBundle() {
		return defaultMessageBundle;
	}

	public void setDefaultMessageBundle(String defaultMessageBundle) {
		this.defaultMessageBundle = defaultMessageBundle;
	}

	protected ResourceBundle createResourceBundle(FacesContext facesContext) {
		final String draftMessageBundle = facesContext.getApplication()
				.getMessageBundle();
		final String messageBundle = draftMessageBundle != null ? draftMessageBundle
				: getDefaultMessageBundle();
		if (messageBundle != null) {
			final ResourceBundle bundle = ResourceBundle
					.getBundle(messageBundle);
			return bundle;
		} else {
			return null;
		}
	}

	private transient ResourceBundle resourceBundle;

	protected ResourceBundle getResourceBundle(FacesContext facesContext) {
		if (resourceBundle == null) {
			resourceBundle = createResourceBundle(facesContext);
		}
		return resourceBundle;
	}

	protected String handleGetObject(String key) {

		final FacesContext facesContext = FacesContext.getCurrentInstance();

		final ResourceBundle resourceBundle = getResourceBundle(facesContext);

		try {
			return resourceBundle.getString(key);
		} catch (NoSuchMessageException nsmex) {
			return "???" + key + "???";
		}

	}

	public int size() {
		throw new UnsupportedOperationException();
	}

	public boolean isEmpty() {
		throw new UnsupportedOperationException();
	}

	public boolean containsKey(Object key) {
		if (key == null) {
			return false;
		} else {
			return (handleGetObject(key.toString()) != null);
		}
	}

	public boolean containsValue(Object value) {
		throw new UnsupportedOperationException();
	}

	public String get(Object key) {
		if (key == null) {
			return null;
		} else {
			return handleGetObject(key.toString());
		}
	}

	public String put(String arg0, String arg1) {
		throw new UnsupportedOperationException();
	}

	public String remove(String key) {
		throw new UnsupportedOperationException();
	}

	public void clear() {
		throw new UnsupportedOperationException();
	}

	public Set<String> keySet() {
		throw new UnsupportedOperationException();
	}

	public Collection<String> values() {
		throw new UnsupportedOperationException();
	}

	public Set<Map.Entry<String, String>> entrySet() {
		throw new UnsupportedOperationException();
	}

	public Enumeration<String> getKeys() {
		throw new UnsupportedOperationException();
	}

	public void putAll(Map<? extends String, ? extends String> t) {
		throw new UnsupportedOperationException();

	}

	public String remove(Object key) {
		throw new UnsupportedOperationException();
	}
}