package org.jvnet.hifaces.text;

import java.io.Serializable;

import javax.faces.context.FacesContext;

/**
 * Textual value binding.
 * 
 * @author valikov
 */
public class Text extends AbstractSingularText implements Serializable {

	private static final long serialVersionUID = 1L;

	private final String messageId;

	private final String expressionString;

	/**
	 * Constructs a new textual value binding for the given message id.
	 * 
	 * @param messageId
	 *            message identifier.
	 */
	public Text(final String messageId) {
		super();
		this.messageId = messageId;
		this.expressionString = "#{text['" + messageId + "']}";
	}

	@Override
	public String getExpressionString() {
		return expressionString;
	}

	@Override
	protected String getMessageId(FacesContext facesContext) {
		return messageId;
	}
}
