package org.jvnet.hifaces.util;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

import org.apache.myfaces.shared.util.MessageUtils;
import org.springframework.context.MessageSourceResolvable;

public class ExceptionMessageUtils {

	private ExceptionMessageUtils() {
	}

	public static void addMessage(MessageSourceResolvable ex,
			FacesMessage.Severity severity, String forClientId,
			FacesContext facesContext) {
		final String[] codes = ex.getCodes();
		final String code = codes[codes.length - 1];
		final Object[] arguments = ex.getArguments();
		MessageUtils.addMessage(severity, code, arguments, forClientId,
				facesContext);
	}

	public static void addMessage(MessageSourceResolvable ex,
			String forClientId, FacesContext facesContext) {
		addMessage(ex, FacesMessage.SEVERITY_ERROR, forClientId, facesContext);

	}

	public static void addMessage(MessageSourceResolvable ex,
			FacesMessage.Severity severity, FacesContext facesContext) {
		addMessage(ex, severity, null, facesContext);

	}

	public static void addMessage(MessageSourceResolvable ex,
			FacesMessage.Severity severity, String forClientId) {
		addMessage(ex, severity, forClientId, FacesContext.getCurrentInstance());

	}

	public static void addMessage(MessageSourceResolvable ex,
			FacesContext facesContext) {
		addMessage(ex, FacesMessage.SEVERITY_ERROR, null, facesContext);

	}

	public static void addMessage(MessageSourceResolvable ex, String forClientId) {
		addMessage(ex, FacesMessage.SEVERITY_ERROR, forClientId, FacesContext
				.getCurrentInstance());

	}

	public static void addMessage(MessageSourceResolvable ex,
			FacesMessage.Severity severity) {
		addMessage(ex, severity, null, FacesContext.getCurrentInstance());

	}

	public static void addMessage(MessageSourceResolvable ex) {
		addMessage(ex, FacesMessage.SEVERITY_ERROR, null, FacesContext
				.getCurrentInstance());

	}

}
